ScaleDraw Class Reference

Extension to QwtScaleDraw. More...

`#include <ScaleDraw.h>`

Inheritance diagram for ScaleDraw:

## Public Types

enum | NameFormat { ShortName, LongName, Initial }
enum | NumericFormat { Automatic, Decimal, Scientific, Superscripts, Engineering, SuperscriptsGER }
enum | ScaleType { Numeric = 0, Text = 1, Day = 2, Month = 3, Time = 4, Date = 5, ColHeader = 6 }
enum | ShowTicksPolicy { ShowAll = 0, HideBegin = 1, HideEnd = 2, HideBeginEnd = 3 }
enum | TicksStyle { None = 0, Out = 1, Both = 2, In = 3 }

## Public Member Functions

int | axis () const
QString | formatString ()
QString | formula ()
virtual QwtText | label (double value) const
void | labelFormat (char &f, int &prec) const
| Return the number format for the major scale labels. More...
NumericFormat | labelNumericFormat ()
int | labelNumericPrecision () const
QStringList | labelsList ()
QString | labelString (double value) const
int | majorTicksStyle () const
int | minorTicksStyle () const
NameFormat | nameFormat ()
Graph * | plot ()
QString | prefix ()
| ScaleDraw (Graph *plot, ScaleDraw *sd)
| Constructs a new scale draw which is a clone of sd. More...
| ScaleDraw (Graph *plot, const QString &formula=QString::null)
| ScaleDraw (Graph *plot, const QStringList &labels, const QString &format, ScaleType type=Text)
ScaleType | scaleType ()
void | setDateFormat (const QString &format)
void | setDayFormat (NameFormat format)
void | setFormula (const QString &formula)
void | setLabelsList (const QStringList &list)
void | setMajorTicksStyle (TicksStyle type)
void | setMinorTicksStyle (TicksStyle type)
void | setMonthFormat (NameFormat format)
void | setNumericFormat (NumericFormat format)
void | setNumericPrecision (int prec)
void | setPrefix (const QString &s)
void | setScaleType (ScaleType type)
void | setSelected (bool select=true)
void | setShowTicksPolicy (const ShowTicksPolicy &policy)
void | setSuffix (const QString &s)
void | setTimeFormat (const QString &format)
ShowTicksPolicy | showTicksPolicy ()
QString | suffix ()
double | transformValue (double value) const

## Protected Member Functions

virtual void | draw (QPainter *, const QPalette &) const
virtual void | drawBackbone (QPainter *painter) const
void | drawBreak (QPainter *) const
void | drawInwardTick (QPainter *painter, double value, int len) const
virtual void | drawLabel (QPainter *painter, double value) const
virtual void | drawTick (QPainter *p, double value, int len) const

## Private Attributes

char | d_fmt
| Numerical format specification. More...
QString | d_format_info
| Stores extra format information: More...
QString | d_formula
| A mathematical expression used to calculate the label values. More...
int | d_majTicks
| Max ticks style. More...
int | d_minTicks
| Min ticks style. More...
NameFormat | d_name_format
| Stores the scale name format for Day and Month scales. More...
NumericFormat | d_numeric_format
| Stores the scale numeric format: Automatic, Decimal, Scientific, Superscripts. More...
Graph * | d_plot
| Pointer to the parent plot. More...
int | d_prec
| Numerical precision. More...
QString | d_prefix
bool | d_selected
| Flag telling if the scale labels are selected (a blue frame is drawn around each labels if true) More...
ShowTicksPolicy | d_show_ticks_policy
QString | d_suffix
QStringList | d_text_labels
| Stores the labels for Txt scales. More...
ScaleType | d_type
| Stores the scale type (numeric, text, etc...). See: enum NumericFormat. More...

## Detailed Description

Extension to QwtScaleDraw.

## Member Enumeration Documentation

enum ScaleDraw::NameFormat

Enumerator
ShortName |
LongName |
Initial |

enum ScaleDraw::NumericFormat

Enumerator
Automatic |
Decimal |
Scientific |
Superscripts |
Engineering |
SuperscriptsGER |

enum ScaleDraw::ScaleType

Enumerator
Numeric |
Text |
Day |
Month |
Time |
Date |
ColHeader |

enum ScaleDraw::ShowTicksPolicy

Enumerator
ShowAll |
HideBegin |
HideEnd |
HideBeginEnd |

enum ScaleDraw::TicksStyle

Enumerator
None |
Out |
Both |
In |

## Constructor & Destructor Documentation

ScaleDraw::ScaleDraw | ( | Graph * | plot,
|  | ScaleDraw * | sd
| ) |  |

Constructs a new scale draw which is a clone of sd.

References d_fmt, d_format_info, d_formula, d_majTicks, d_minTicks, d_name_format, d_numeric_format, d_prec, d_prefix, d_selected, d_show_ticks_policy, d_suffix, d_text_labels, d_type, prefix(), showTicksPolicy(), and suffix().

ScaleDraw::ScaleDraw | ( | Graph * | plot,
|  | const QString & | formula = `QString::null`
| ) |  |

ScaleDraw::ScaleDraw | ( | Graph * | plot,
|  | const QStringList & | labels,
|  | const QString & | format,
|  | ScaleType | type = `Text`
| ) |  |

## Member Function Documentation

int ScaleDraw::axis | ( |  | ) | const

Referenced by drawBackbone(), drawBreak(), drawInwardTick(), drawLabel(), drawTick(), and labelString().

void ScaleDraw::draw | ( | QPainter * | painter,
|  | const QPalette & | palette
| ) |  | const

protected virtual

References Both, d_majTicks, d_minTicks, d_plot, drawBreak(), drawInwardTick(), Graph::isPrinting(), Graph::majorTickLength(), and Graph::minorTickLength().

Referenced by drawInwardTick().

void ScaleDraw::drawBackbone | ( | QPainter * | painter | ) | const

protected virtual

References axis(), ScaleEngine::axisBreakLeft(), ScaleEngine::axisBreakRight(), d_plot, ScaleEngine::hasBreak(), and Graph::isPrinting().

void ScaleDraw::drawBreak | ( | QPainter * | painter | ) | const

protected

References axis(), ScaleEngine::axisBreakLeft(), ScaleEngine::axisBreakRight(), d_plot, ScaleEngine::hasBreak(), ScaleEngine::hasBreakDecoration(), Graph::isPrinting(), and Graph::majorTickLength().

Referenced by draw().

void ScaleDraw::drawInwardTick | ( | QPainter * | painter,
|  | double | value,
|  | int | len
| ) |  | const

protected

References axis(), ScaleEngine::axisBreakLeft(), ScaleEngine::axisBreakRight(), d_plot, draw(), and ScaleEngine::hasBreak().

Referenced by draw().

void ScaleDraw::drawLabel | ( | QPainter * | painter,
|  | double | value
| ) |  | const

protected virtual

References axis(), ScaleEngine::axisBreakLeft(), ScaleEngine::axisBreakRight(), d_plot, d_selected, d_show_ticks_policy, ScaleEngine::hasBreak(), HideBegin, HideBeginEnd, HideEnd, and ShowAll.

void ScaleDraw::drawTick | ( | QPainter * | p,
|  | double | value,
|  | int | len
| ) |  | const

protected virtual

References axis(), ScaleEngine::axisBreakLeft(), ScaleEngine::axisBreakRight(), d_majTicks, d_minTicks, d_plot, d_show_ticks_policy, ScaleEngine::hasBreak(), HideBegin, HideBeginEnd, HideEnd, In, Graph::isPrinting(), None, and ShowAll.

QString ScaleDraw::formatString | ( |  | ) |

inline

References d_format_info.

Referenced by Graph::copyScaleDraw(), Graph::saveAxesLabelsType(), Graph::setLabelsDateTimeFormat(), Graph::setLabelsTextFormat(), Graph::showAxis(), AxesDialog::showAxisFormatOptions(), and Graph::updateSecondaryAxis().

QString ScaleDraw::formula | ( |  | ) |

inline

References d_formula.

Referenced by Graph::axisFormula(), Graph::copyScaleDraw(), Graph::saveAxesFormulas(), setFormula(), Graph::setLabelsNumericFormat(), and Graph::showAxis().

QwtText ScaleDraw::label | ( | double | value | ) | const

virtual

References d_plot, d_prefix, d_suffix, and labelString().

void ScaleDraw::labelFormat | ( | char & | f,
|  | int & | prec
| ) |  | const

Return the number format for the major scale labels.

Format character and precision have the same meaning as for sprintf().

Parameters

  f | format character 'e', 'f' or 'g'

  prec

  - for 'e', 'f': the number of digits after the radix character (point)
  - for 'g': the maximum number of significant digits

See also
  setNumericFormat()

References d_fmt, and d_prec.

Referenced by Graph::axisLabelFormat().

NumericFormat ScaleDraw::labelNumericFormat | ( |  | ) |

inline

References d_numeric_format.

Referenced by Graph::axisLabelFormat().

int ScaleDraw::labelNumericPrecision | ( |  | ) | const

inline

References d_prec.

Referenced by Graph::axisLabelPrecision().

QStringList ScaleDraw::labelsList | ( |  | ) |

inline

References d_text_labels.

Referenced by Graph::copyScaleDraw(), and Graph::setLabelsTextFormat().

QString ScaleDraw::labelString | ( | double | value | ) | const

References axis(), ScaleEngine::axisBreakLeft(), ScaleEngine::axisBreakRight(), ColHeader, d_fmt, d_format_info, d_name_format, d_numeric_format, d_plot, d_prec, d_text_labels, d_type, Date, Table::dateTime(), Day, Engineering, ScaleEngine::hasBreak(), Initial, LongName, Month, Graph::multiLayer(), Numeric, ShortName, sign, Superscripts, SuperscriptsGER, Text, Time, and transformValue().

Referenced by label().

int ScaleDraw::majorTicksStyle | ( |  | ) | const

inline

References d_majTicks.

Referenced by Graph::copyScaleDraw(), Graph::drawItems(), and Graph::getMajorTicksType().

int ScaleDraw::minorTicksStyle | ( |  | ) | const

inline

References d_minTicks.

Referenced by Graph::copyScaleDraw(), Graph::drawItems(), and Graph::getMinorTicksType().

NameFormat ScaleDraw::nameFormat | ( |  | ) |

inline

References d_name_format.

Referenced by Graph::copyScaleDraw(), and Graph::updateSecondaryAxis().

Graph* ScaleDraw::plot | ( |  | ) |

inline

References d_plot.

QString ScaleDraw::prefix | ( |  | ) |

inline

References d_prefix.

Referenced by Graph::copyScaleDraw(), Graph::saveLabelsPrefixAndSuffix(), ScaleDraw(), Graph::showAxis(), and AxesDialog::updateCurrentAxis().

ScaleType ScaleDraw::scaleType | ( |  | ) |

inline

References d_type.

Referenced by Graph::copyScaleDraw(), Graph::insertCurve(), Graph::saveAxesLabelsType(), Graph::setLabelsDateTimeFormat(), Graph::setLabelsTextFormat(), Graph::showAxis(), and Graph::updateSecondaryAxis().

void ScaleDraw::setDateFormat | ( | const QString & | format | ) |

References d_format_info, d_type, and Date.

Referenced by Graph::setLabelsDateTimeFormat().

void ScaleDraw::setDayFormat | ( | NameFormat | format | ) |

References d_name_format, d_type, and Day.

Referenced by Graph::setLabelsDayFormat().

void ScaleDraw::setFormula | ( | const QString & | formula | ) |

inline

References d_formula, and formula().

Referenced by Graph::setAxisFormula().

void ScaleDraw::setLabelsList | ( | const QStringList & | list | ) |

inline

References d_text_labels.

void ScaleDraw::setMajorTicksStyle | ( | TicksStyle | type | ) |

inline

References d_majTicks.

Referenced by Graph::setAxisTicksLength(), and Graph::setMajorTicksType().

void ScaleDraw::setMinorTicksStyle | ( | TicksStyle | type | ) |

inline

References d_minTicks.

Referenced by Graph::setAxisTicksLength(), and Graph::setMinorTicksType().

void ScaleDraw::setMonthFormat | ( | NameFormat | format | ) |

References d_name_format, d_type, and Month.

Referenced by Graph::setLabelsMonthFormat().

void ScaleDraw::setNumericFormat | ( | NumericFormat | format | ) |

References Automatic, d_fmt, d_numeric_format, d_type, Decimal, Engineering, Numeric, Scientific, Superscripts, and SuperscriptsGER.

Referenced by Graph::setLabelsNumericFormat().

void ScaleDraw::setNumericPrecision | ( | int | prec | ) |

inline

References d_prec.

Referenced by Graph::setLabelsNumericFormat().

void ScaleDraw::setPrefix | ( | const QString & | s | ) |

inline

References d_prefix.

Referenced by Graph::copyScaleDraw(), ApplicationWindow::openGraph(), and Graph::showAxis().

void ScaleDraw::setScaleType | ( | ScaleType | type | ) |

inline

References d_type.

void ScaleDraw::setSelected | ( | bool | select = `true` | ) |

inline

References d_selected.

Referenced by ScalePicker::deselect(), and ScalePicker::selectLabels().

void ScaleDraw::setShowTicksPolicy | ( | const ShowTicksPolicy & | policy | ) |

inline

References d_show_ticks_policy.

Referenced by AxesDialog::applyAxisFormatToLayer(), Graph::copyScaleDraw(), ApplicationWindow::openGraph(), FFT::outputGraphs(), Graph::plotBox(), MultiLayer::setCommonLayerAxes(), and Graph::showAxis().

void ScaleDraw::setSuffix | ( | const QString & | s | ) |

inline

References d_suffix.

Referenced by Graph::copyScaleDraw(), ApplicationWindow::openGraph(), and Graph::showAxis().

void ScaleDraw::setTimeFormat | ( | const QString & | format | ) |

References d_format_info, d_type, and Time.

Referenced by Graph::setLabelsDateTimeFormat().

ShowTicksPolicy ScaleDraw::showTicksPolicy | ( |  | ) |

inline

References d_show_ticks_policy.

Referenced by Graph::copyScaleDraw(), Graph::saveTickLabelsSpace(), ScaleDraw(), Graph::showAxis(), and AxesDialog::updateCurrentAxis().

QString ScaleDraw::suffix | ( |  | ) |

inline

References d_suffix.

Referenced by Graph::copyScaleDraw(), Graph::saveLabelsPrefixAndSuffix(), ScaleDraw(), Graph::showAxis(), and AxesDialog::updateCurrentAxis().

double ScaleDraw::transformValue | ( | double | value | ) | const

References d_formula.

Referenced by labelString().

## Member Data Documentation

char ScaleDraw::d_fmt

private

Numerical format specification.

Referenced by labelFormat(), labelString(), ScaleDraw(), and setNumericFormat().

QString ScaleDraw::d_format_info

private

Stores extra format information:

Referenced by formatString(), labelString(), ScaleDraw(), setDateFormat(), and setTimeFormat().

QString ScaleDraw::d_formula

private

A mathematical expression used to calculate the label values.

Referenced by formula(), ScaleDraw(), setFormula(), and transformValue().

int ScaleDraw::d_majTicks

private

Max ticks style.

Referenced by draw(), drawTick(), majorTicksStyle(), ScaleDraw(), and setMajorTicksStyle().

int ScaleDraw::d_minTicks

private

Min ticks style.

Referenced by draw(), drawTick(), minorTicksStyle(), ScaleDraw(), and setMinorTicksStyle().

NameFormat ScaleDraw::d_name_format

private

Stores the scale name format for Day and Month scales.

Referenced by labelString(), nameFormat(), ScaleDraw(), setDayFormat(), and setMonthFormat().

NumericFormat ScaleDraw::d_numeric_format

private

Stores the scale numeric format: Automatic, Decimal, Scientific, Superscripts.

Referenced by labelNumericFormat(), labelString(), ScaleDraw(), and setNumericFormat().

Graph* ScaleDraw::d_plot

private

Pointer to the parent plot.

Referenced by draw(), drawBackbone(), drawBreak(), drawInwardTick(), drawLabel(), drawTick(), label(), labelString(), and plot().

int ScaleDraw::d_prec

private

Numerical precision.

Referenced by labelFormat(), labelNumericPrecision(), labelString(), ScaleDraw(), and setNumericPrecision().

QString ScaleDraw::d_prefix

private

Referenced by label(), prefix(), ScaleDraw(), and setPrefix().

bool ScaleDraw::d_selected

private

Flag telling if the scale labels are selected (a blue frame is drawn around each labels if true)

Referenced by drawLabel(), ScaleDraw(), and setSelected().

ShowTicksPolicy ScaleDraw::d_show_ticks_policy

private

Referenced by drawLabel(), drawTick(), ScaleDraw(), setShowTicksPolicy(), and showTicksPolicy().

QString ScaleDraw::d_suffix

private

Referenced by label(), ScaleDraw(), setSuffix(), and suffix().

QStringList ScaleDraw::d_text_labels

private

Stores the labels for Txt scales.

Referenced by labelsList(), labelString(), ScaleDraw(), and setLabelsList().

ScaleType ScaleDraw::d_type

private

Stores the scale type (numeric, text, etc...). See: enum NumericFormat.

Referenced by labelString(), ScaleDraw(), scaleType(), setDateFormat(), setDayFormat(), setMonthFormat(), setNumericFormat(), setScaleType(), and setTimeFormat().

The documentation for this class was generated from the following files:

- qtiplot/src/plot2D/ScaleDraw.h
- qtiplot/src/plot2D/ScaleDraw.cpp